@rem = '
@rem -*- Perl -*-
@echo off
..\perl %0.cmd %1 %2 %3 %4 %5 %6 %7 %8 %9
goto endofperl
';
# $RCSfile: TEST,v $$Revision: 4.0.1.1 $$Date: 91/06/07 11:59:30 $

# This is written in a peculiar style, since we're trying to avoid
# most of the constructs we'll be testing for.

$| = 1;

if ($ARGV[0] eq '-v') {
    $verbose = 1;
    shift;
}

chdir 't' if -f 't/nttest.cmd';

chop ($wd = `cd`);
$wd =~ tr/A-Z/a-z/;
$exedir = $wd;
$exedir =~ s,[\\/]t$,,;

#
# put our just-made version of perl at the head of the path
#

$ENV{'Path'} = "$exedir;$ENV{'Path'}";
$ENV{'PERLLIB'} = "$execdir\\lib";

if ($ARGV[0] eq '') {
	@ARGV = <base\\*.nt comp\\*.nt cmd\\*.nt io\\*.nt op\\*.nt lib\\*.nt>;
}

$bad = 0;
while ($test = shift) {	 
    if ($test =~ /^$/) {
	next;
    }
    $te = $test;
    substr ($te, -2) = '';
    print "$te" . '.' x (15 - length($te));
    open(script,"$test") || die "Can't run $test.\n";
    $_ = <script>;
    close(script);
    if (/#!..perl(.*)/) {
       $switch = $1;
    } else {
	$switch = '';
    }
    open(results,"perl$switch $test|") || (print "can't run.\n");

    $ok = 0;
    $next = 0;
    while (<results>) {
	if ($verbose) {
	    print $_;
	}
	unless (/^#/) {
	    if (/^1\.\.([0-9]+)/) {
		$max = $1;
		$totmax += $max;
		$files += 1;
		$next = 1;
		$ok = 1;
	    } else {
		$next = $1, $ok = 0, last if /^not ok ([0-9]*)/;
		if (/^ok (.*)/ && $1 == $next) {
		    $next = $next + 1;
		} else {
		    $ok = 0;
		}
	    }
	}
    }
    $next = $next - 1;
    if ($ok && $next == $max) {
	print "ok\n";
    } else {
	$next += 1;
	print "FAILED on test $next\n";
	$bad = $bad + 1;
	$_ = $test;
	if (/^base/) {
	    die "Failed a basic test--cannot continue.\n";
	}
    }
}

if ($bad == 0) {
    if ($ok) {
	print "All tests successful.\n";
    } else {
	die "FAILED--no tests were run for some reason.\n";
    }
} else {
    if ($bad == 1) {
	die "Failed 1 test.\n";
    } else {
	die "Failed $bad tests.\n";
    }
}
#($user,$sys,$cuser,$csys) = times;
#print sprintf("u=%g  s=%g  cu=%g  cs=%g  files=%d  tests=%d\n",
#	      $user,$sys,$cuser,$csys,$files,$totmax);

__END__
:endofperl

